MUITeammate = MUITeammate or class()
Hooks:PostHook(MUITeammate, "create_radial_panel", "create_radial_panel____", function(self, parent)
    local panel = self._radial_health_panel
    self.copr_overlay_panel = panel:panel({
		name = "copr_overlay_panel",
		layer = 3,
		w = panel:w(),
		h = panel:h()
	})
    if self._main_player then
		self.radial_rip_bg = panel:bitmap({
			texture = "guis/textures/pd2/hud_rip_bg",
			name = "radial_rip_bg",
			layer = 1,
			visible = false,
			render_template = "VertexColorTexturedRadial",
			texture_rect = {
				128,
				0,
				-128,
				128
			},
			color = Color(1, 0, 0, 0),
			w = panel:w(),
			h = panel:h()
		})
	end
end)

Hooks:PostHook(MUITeammate, "set_health", "set_health___", function(self, data)
    local dt, dc, dr = data.total, data.current, data.revives;
	local hp, rip = self._radial_health, self._radial_rip;
	local radial_rip_bg = self.radial_rip_bg
	local red = data.current / data.total
    if managers.player:has_activate_temporary_upgrade("temporary", "copr_ability") and self._id == HUDManager.PLAYER_PANEL then
		local static_damage_ratio = managers.player:upgrade_value_nil("player", "copr_static_damage_ratio")
		hp:stop()

		if static_damage_ratio then
			red = math.floor((red + 0.01) / static_damage_ratio) * static_damage_ratio
		end

		local copr_overlay_panel = self.copr_overlay_panel

		if alive(copr_overlay_panel) then
			for _, notch in ipairs(copr_overlay_panel:children()) do
				notch:set_visible(notch:script().red <= red + 0.01)
			end
		end

		if red < hp:color().red then
			self:_damage_taken()
			hp:set_color(Color(1, red, 1, 1))
		else
			hp:animate(function (o)
				local s = hp:color().r
				local e = red
				local health_ratio = nil

				over(0.2, function (p)
					health_ratio = math.lerp(s, e, p)

					hp:set_color(Color(1, health_ratio, 1, 1))

					if alive(copr_overlay_panel) then
						for _, notch in ipairs(copr_overlay_panel:children()) do
							notch:set_visible(notch:script().red <= health_ratio + 0.01)
						end
					end
				end)
			end)
		end
    end
end)

function MUITeammate:set_copr_indicator(enabled, static_damage_ratio)
	local teammate_panel = self._panel:child("player")
	local radial_health_panel = self._radial_health_panel
	local copr_overlay_panel = radial_health_panel:child("copr_overlay_panel")
	local radial_health = radial_health_panel:child("radial_health")
	local red = radial_health:color().r
	local main = self._main_player;
	local size = main and self._muiSizeL or self._muiSizeS
	local notch_size = 7
	if size > 20 then
		notch_size = ((size/1.5) * 1)/2
	end

	if alive(copr_overlay_panel) then
		copr_overlay_panel:clear()
		copr_overlay_panel:set_visible(enabled)

		if enabled then
			local num_notches = math.ceil(1 / static_damage_ratio)
			local rotation = nil
			local cx, cy = copr_overlay_panel:center()
			local v1 = Vector3()
			local v2 = Vector3()
			local v3 = Vector3()
			local mset = mvector3.set_static
			local x, y = nil
			local w = 5
			local h = math.min(copr_overlay_panel:w(), copr_overlay_panel:h()) / 6

			for i = 0, num_notches - 1 do
				rotation = i / num_notches * 360
				x = cx + math.sin(rotation) * notch_size
				y = cy - math.cos(rotation) * notch_size

				mset(v1, 0, h, 0)
				mset(v2, w, h, 0)
				mset(v3, w / 2, 0, 0)

				local notch = copr_overlay_panel:polygon({
					layer = 0,
					name = tostring(i),
					color = Color.black:with_alpha(0.6),
					rotation = rotation,
					triangles = {
						v1,
						v2,
						v3
					},
					w = w,
					h = h
				})
				notch:script().red = 1 - i / num_notches

				notch:set_visible(notch:script().red <= red + 0.01)
				notch:set_center(x, y)
			end
		end
	end
end